Index: /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/FacetConstants.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/FacetConstants.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/FacetConstants.java	(revision 6412)
@@ -84,5 +84,5 @@
      * 1 matches the ISO639-3 language code)
      */
-    public static final String DESCRIPTION_LANGUAGE_PATTERN = "^\\{lang='([a-z]{3})'\\}";
+    public static final String DESCRIPTION_LANGUAGE_PATTERN = "^\\{lang='([A-z-]+)'\\}";
 
     /**
Index: /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/AbstractXmlVloConfigFactory.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/AbstractXmlVloConfigFactory.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/AbstractXmlVloConfigFactory.java	(revision 6412)
@@ -42,5 +42,5 @@
         final InputStream fileStream = getXmlConfigurationInputStream();
         try {
-            final VloConfig config = marshaller.unmarshal(new StreamSource(fileStream));
+            final VloConfig config = marshaller.unmarshal(new StreamSource(fileStream, getLocation().toString()));
             config.setConfigLocation(getLocation());
             return config;
@@ -59,5 +59,5 @@
      */
     protected abstract InputStream getXmlConfigurationInputStream() throws IOException;
-    
+
     protected abstract URI getLocation();
 
Index: /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/VloConfigMarshaller.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/VloConfigMarshaller.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/main/java/eu/clarin/cmdi/vlo/config/VloConfigMarshaller.java	(revision 6412)
@@ -21,7 +21,13 @@
 import javax.xml.bind.Marshaller;
 import javax.xml.bind.Unmarshaller;
+import javax.xml.parsers.ParserConfigurationException;
+import javax.xml.parsers.SAXParserFactory;
 import javax.xml.transform.Result;
 import javax.xml.transform.Source;
+import javax.xml.transform.sax.SAXSource;
 import javax.xml.transform.stream.StreamResult;
+import org.xml.sax.InputSource;
+import org.xml.sax.SAXException;
+import org.xml.sax.XMLReader;
 
 /**
@@ -60,6 +66,23 @@
      */
     public final VloConfig unmarshal(Source source) throws JAXBException {
-        Unmarshaller unmarshaller = jc.createUnmarshaller();
-        return (VloConfig) unmarshaller.unmarshal(source);
+        final Unmarshaller unmarshaller = jc.createUnmarshaller();
+        
+        // custom parser, so that we can make it XInclude aware
+        final SAXParserFactory spf = SAXParserFactory.newInstance();
+        spf.setXIncludeAware(true);
+	spf.setNamespaceAware(true);
+
+        try {
+            final XMLReader xr = spf.newSAXParser().getXMLReader();
+            // XML transformation 'source' needs to be converted to a SAX 'input source'
+            final InputSource inputSource = SAXSource.sourceToInputSource(source);
+            final SAXSource saxSource = new SAXSource(xr, inputSource);
+
+            return (VloConfig) unmarshaller.unmarshal(saxSource);
+        } catch (ParserConfigurationException ex) {
+            throw new JAXBException(ex);
+        } catch (SAXException ex) {
+            throw new JAXBException(ex);
+        }
     }
 
Index: /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/DefaultVloConfigFactoryTest.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/DefaultVloConfigFactoryTest.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/DefaultVloConfigFactoryTest.java	(revision 6412)
@@ -4,4 +4,5 @@
 import java.util.Arrays;
 import java.util.List;
+import java.util.Properties;
 import java.util.Set;
 import static org.hamcrest.CoreMatchers.hasItems;
@@ -20,8 +21,11 @@
 
     private VloConfig config;
+    private Properties testProps;
 
     @Before
     public void setUp() throws Exception {
         config = new DefaultVloConfigFactory().newConfig();
+        testProps = new Properties();
+        testProps.load(getClass().getResourceAsStream("/vloconfig.properties"));
     }
 
@@ -34,17 +38,15 @@
     @Test
     public void testGetDataRoots() {
-
-        List<DataRoot> dataRoots = Arrays.asList(
-                new DataRoot("CLARIN Centres",
-                        new File("/lat/apache/htdocs/oai-harvester/clarin/results/cmdi/"),
-                        "http://catalog.clarin.eu/",
-                        "/lat/apache/htdocs/", false),
-                new DataRoot("Other",
-                        new File("/lat/apache/htdocs/oai-harvester/others/results/cmdi"),
-                        "http://catalog.clarin.eu/",
-                        "/lat/apache/htdocs/", false));
-
-        List<DataRoot> rootsReturned = config.getDataRoots();
-        assertArrayEquals(dataRoots.toArray(), rootsReturned.toArray());
+        final List<DataRoot> rootsReturned = config.getDataRoots();
+
+        assertNotNull(rootsReturned);
+        assertTrue("One or more data roots should be defined", rootsReturned.size() > 0);
+        assertNotNull(rootsReturned.get(0).getOriginName());
+        assertTrue("Origin name cannot be empty", rootsReturned.get(0).getOriginName().length() > 0);
+        assertNotNull(rootsReturned.get(0).getPrefix());
+        assertTrue("Prefix cannot be empty", rootsReturned.get(0).getPrefix().length() > 0);
+        assertNotNull(rootsReturned.get(0).getRootFile());
+        assertTrue("Root file cannot be empty", rootsReturned.get(0).getRootFile().getName().length() > 0);
+        assertNotNull(rootsReturned.get(0).getToStrip());
     }
 
@@ -272,5 +274,5 @@
         System.out.println("deleteAllFirst");
 
-        boolean expResult = true;
+        boolean expResult = Boolean.valueOf(testProps.getProperty("deleteAllFirst"));
         boolean result = config.getDeleteAllFirst();
 
@@ -333,5 +335,5 @@
         System.out.println("getVloHomeLink");
 
-        String expResult = "http://www.clarin.eu/vlo";
+        String expResult = testProps.getProperty("homeUrl");
         String result = config.getHomeUrl();
 
@@ -364,5 +366,5 @@
         System.out.println("getHelpUrl");
 
-        String expResult = "http://www.clarin.eu/vlo";
+        String expResult = testProps.getProperty("helpUrl");
         String result = config.getHelpUrl();
 
@@ -395,5 +397,5 @@
         System.out.println("getSolrUrl");
 
-        String expResult = "http://localhost:8080/vlo-solr/core0/";
+        String expResult = testProps.getProperty("solrUrl");
         String result = config.getSolrUrl();
 
Index: /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/VloConfigMarshallerTest.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/VloConfigMarshallerTest.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-commons/src/test/java/eu/clarin/cmdi/vlo/config/VloConfigMarshallerTest.java	(revision 6412)
@@ -21,4 +21,5 @@
 import java.io.StringWriter;
 import java.util.Arrays;
+import java.util.Properties;
 import javax.xml.transform.stream.StreamResult;
 import javax.xml.transform.stream.StreamSource;
@@ -31,15 +32,19 @@
 
 /**
- * 
+ *
  * @author twagoo
  */
 public class VloConfigMarshallerTest {
     
+    private final static String VLO_CONFIG_FILE = "/VloConfig.xml";
     private final static Logger logger = LoggerFactory.getLogger(VloConfigMarshallerTest.class);
     private VloConfigMarshaller instance;
+    private Properties testProps;
     
     @Before
     public void setUp() throws Exception {
         instance = new VloConfigMarshaller();
+        testProps = new Properties();
+        testProps.load(getClass().getResourceAsStream("/vloconfig.properties"));
     }
 
@@ -49,11 +54,10 @@
     @Test
     public void testUnmarshal() throws Exception {
-        InputStream configFile = getClass().getResourceAsStream("/VloConfig.xml");
-        VloConfig config = instance.unmarshal(new StreamSource(configFile));
+        InputStream configFile = getClass().getResourceAsStream(VLO_CONFIG_FILE);
+        VloConfig config = instance.unmarshal(new StreamSource(configFile, getClass().getResource(VLO_CONFIG_FILE).toString()));
         configFile.close();
         
         assertNotNull(config);
-        assertEquals("http://localhost:8080/vlo-solr/core0/", config.getSolrUrl());
-        assertEquals(2, config.getDataRoots().size());
+        assertEquals(testProps.getProperty("solrUrl"), config.getSolrUrl());
         assertEquals(14, config.getFacetFields().size());
     }
Index: /vlo/branches/vlo-3.3-oeaw/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIParserVTDXML.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIParserVTDXML.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-importer/src/main/java/eu/clarin/cmdi/vlo/importer/CMDIParserVTDXML.java	(revision 6412)
@@ -38,15 +38,23 @@
     @Override
     public CMDIData process(File file) throws VTDException, IOException {
-        CMDIData cmdiData = new CMDIData();
-        VTDGen vg = new VTDGen();
-        FileInputStream fileInputStream = new FileInputStream(file);
-        vg.setDoc(IOUtils.toByteArray(fileInputStream));
-        vg.parse(true);
-        fileInputStream.close();
-
+        final CMDIData cmdiData = new CMDIData();
+        final VTDGen vg = new VTDGen();
+        final FileInputStream fileInputStream = new FileInputStream(file);
+        try {
+            vg.setDoc(IOUtils.toByteArray(fileInputStream));
+            vg.parse(true);
+        } finally {
+            fileInputStream.close();
+        }
+
+<<<<<<< .working
         VTDNav nav = vg.getNav();
         String profileId = extractXsd(nav.cloneNav());
         cmdiData.setProfileId(profileId);
         FacetMapping facetMapping = getFacetMapping(profileId);
+=======
+        final VTDNav nav = vg.getNav();
+        final FacetMapping facetMapping = getFacetMapping(nav.cloneNav());
+>>>>>>> .merge-right.r6411
 
         if (facetMapping.getFacets().isEmpty()) {
Index: /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/VloWicketApplication.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/VloWicketApplication.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/VloWicketApplication.java	(revision 6412)
@@ -14,4 +14,7 @@
 import eu.clarin.cmdi.vlo.wicket.pages.VloBasePage;
 import eu.clarin.cmdi.vlo.wicket.provider.FieldValueConverterProvider;
+import java.io.IOException;
+import java.io.InputStream;
+import java.util.Properties;
 import javax.inject.Inject;
 import org.apache.wicket.Application;
@@ -51,4 +54,5 @@
 
     private ApplicationContext applicationContext;
+    private String appVersionQualifier;
 
     /**
@@ -76,4 +80,8 @@
         // configure Wicket cache according to parameters set in VloConfig 
         setupCache();
+
+        // determine version qualifier (e.g. 'beta'), which can be used to visually mark the base page
+        appVersionQualifier = determineVersionQualifier();
+        logger.info("Version qualifier: {}", appVersionQualifier);
     }
 
@@ -127,4 +135,26 @@
     /**
      *
+     * @return a version qualifier, either 'snapshot', 'beta' or null
+     */
+    private String determineVersionQualifier() {
+        try (InputStream applicationPropertiesStream = getClass().getResourceAsStream("/application.properties")) {
+            Properties applicationProperties = new Properties();
+            applicationProperties.load(applicationPropertiesStream);
+            final String version = applicationProperties.getProperty("vlo.version");
+            if (version != null) {
+                if (version.endsWith("-SNAPSHOT")) {
+                    return "snapshot";
+                } else if (version.contains("beta")) {
+                    return "beta";
+                }
+            }
+        } catch (IOException ex) {
+            logger.error("Could not read application properties on init", ex);
+        }
+        return null;
+    }
+
+    /**
+     *
      * @return the active VLO wicket application
      */
@@ -173,3 +203,7 @@
     }
 
+    public String getAppVersionQualifier() {
+        return appVersionQualifier;
+    }
+
 }
Index: /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/ResourceStringConverterImpl.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/ResourceStringConverterImpl.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/service/impl/ResourceStringConverterImpl.java	(revision 6412)
@@ -28,4 +28,6 @@
 import java.util.regex.Pattern;
 import org.apache.commons.io.FilenameUtils;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
 
 /**
@@ -34,4 +36,6 @@
  */
 public class ResourceStringConverterImpl implements ResourceStringConverter {
+
+    private final static Logger logger = LoggerFactory.getLogger(ResourceStringConverterImpl.class);
 
     private final static String SPLIT_PATTERN = Pattern.quote(FacetConstants.FIELD_RESOURCE_SPLIT_CHAR);
@@ -83,7 +87,9 @@
                 return href;
             } else {
-                return FilenameUtils.getName(path);
+                //strip trailing slash, then get name
+                return FilenameUtils.getName(path.replaceAll("\\/$", ""));
             }
         } catch (URISyntaxException ex) {
+            logger.debug("Invalid URI, coult not extract file name: {}", href, ex);
             return href;
         }
Index: /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/IndicatingNestedTree.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/IndicatingNestedTree.java	(revision 6412)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/components/IndicatingNestedTree.java	(revision 6412)
@@ -0,0 +1,81 @@
+/*
+ * Copyright (C) 2015 Max Planck Institute for Psycholinguistics
+ *
+ * This program is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program.  If not, see <http://www.gnu.org/licenses/>.
+ */
+package eu.clarin.cmdi.vlo.wicket.components;
+
+import java.util.Set;
+import org.apache.wicket.Component;
+import org.apache.wicket.MarkupContainer;
+import org.apache.wicket.ajax.AjaxRequestTarget;
+import org.apache.wicket.extensions.ajax.markup.html.IndicatingAjaxFallbackLink;
+import org.apache.wicket.extensions.markup.html.repeater.tree.DefaultNestedTree;
+import org.apache.wicket.extensions.markup.html.repeater.tree.ITreeProvider;
+import org.apache.wicket.extensions.markup.html.repeater.tree.Node;
+import org.apache.wicket.model.IModel;
+
+/**
+ * Nesting tree that has {@link IndicatingAjaxFallbackLink} instances for
+ * junction links so that an indicator is shown when a user expands a node.
+ *
+ * @author Twan Goosen <twan.goosen@mpi.nl>
+ * @param <T>
+ */
+public abstract class IndicatingNestedTree<T> extends DefaultNestedTree<T> {
+
+    public IndicatingNestedTree(String id, ITreeProvider<T> provider) {
+        super(id, provider);
+    }
+
+    public IndicatingNestedTree(String id, ITreeProvider<T> provider, IModel<Set<T>> state) {
+        super(id, provider, state);
+    }
+
+    @Override
+    public Component newNodeComponent(String id, final IModel<T> model) {
+        // when aksed to create a node, return an instance that provides an indicating link for junctions
+        final Node<T> node = new Node<T>(id, this, model) {
+            private static final long serialVersionUID = 1L;
+
+            @Override
+            protected Component createContent(String id, IModel<T> model) {
+                // copied from NestedTree
+                return IndicatingNestedTree.this.newContentComponent(id, model);
+            }
+
+            @Override
+            protected MarkupContainer createJunctionComponent(String id) {
+                // based on the default implementation in Node, but returning an indicating link instead
+                return new IndicatingAjaxFallbackLink<Void>(id) {
+                    private static final long serialVersionUID = 1L;
+
+                    @Override
+                    public void onClick(AjaxRequestTarget target) {
+                        toggle();
+                    }
+
+                    @Override
+                    public boolean isEnabled() {
+                        return IndicatingNestedTree.this.getProvider().hasChildren(model.getObject());
+                    }
+                };
+            }
+
+        };
+        node.setOutputMarkupId(true);
+        return node;
+    }
+
+}
Index: /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/AllFacetValuesPage.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/AllFacetValuesPage.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/AllFacetValuesPage.java	(revision 6412)
@@ -17,6 +17,8 @@
 package eu.clarin.cmdi.vlo.wicket.pages;
 
+import eu.clarin.cmdi.vlo.config.VloConfig;
 import eu.clarin.cmdi.vlo.pojo.FacetSelection;
 import eu.clarin.cmdi.vlo.pojo.QueryFacetsSelection;
+import eu.clarin.cmdi.vlo.service.FacetParameterMapper;
 import eu.clarin.cmdi.vlo.service.PageParametersConverter;
 import eu.clarin.cmdi.vlo.service.solr.FacetFieldsService;
@@ -33,4 +35,5 @@
 import org.apache.wicket.model.Model;
 import org.apache.wicket.model.PropertyModel;
+import org.apache.wicket.request.http.flow.AbortWithHttpErrorCodeException;
 import org.apache.wicket.request.mapper.parameter.PageParameters;
 import org.apache.wicket.spring.injection.annot.SpringBean;
@@ -47,6 +50,10 @@
     @SpringBean
     private FacetFieldsService facetFieldsService;
-    @SpringBean(name="queryParametersConverter")
+    @SpringBean(name = "queryParametersConverter")
     private PageParametersConverter<QueryFacetsSelection> parametersConverter;
+    @SpringBean
+    private FacetParameterMapper facetParamMapper;
+    @SpringBean
+    private VloConfig vloConfig;
 
     private final IModel<QueryFacetsSelection> selectionModel;
@@ -56,15 +63,19 @@
 
         this.selectionModel = Model.of(parametersConverter.fromParameters(params));
-        final StringValue facet = params.get(SELECTED_FACET_PARAM);
-        if (facet.isEmpty()) {
+        final StringValue facetValue = params.get(SELECTED_FACET_PARAM);
+        if (facetValue.isEmpty()) {
             Session.get().error("No facet provided for all values page");
             throw new RestartResponseException(new FacetedSearchPage(selectionModel));
         }
 
-        // create a new model so that all values will be retrieved
-        setModel(new FacetFieldModel(facetFieldsService, facet.toString(), selectionModel, -1)); // gets all facet values
+        final String facet = facetParamMapper.getFacet(facetValue.toString());
+
+        if (vloConfig.getAllFacetFields().contains(facet)) {
+            // create a new model so that all values will be retrieved
+            setModel(new FacetFieldModel(facetFieldsService, facet, selectionModel, -1)); // gets all facet values
+        }
         if (getModelObject() == null) {
-            Session.get().error(String.format("Facet '%s' could not be found", facet));
-            throw new RestartResponseException(new FacetedSearchPage(selectionModel));
+            final String message = String.format("Facet '%s' could not be found", facet);
+            throw new AbortWithHttpErrorCodeException(404, message);
         }
 
Index: /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/VloBasePage.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/VloBasePage.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/pages/VloBasePage.java	(revision 6412)
@@ -19,4 +19,5 @@
 import eu.clarin.cmdi.vlo.JavaScriptResources;
 import eu.clarin.cmdi.vlo.VloWebAppParameters;
+import eu.clarin.cmdi.vlo.VloWicketApplication;
 import eu.clarin.cmdi.vlo.config.VloConfig;
 import eu.clarin.cmdi.vlo.wicket.HideJavascriptFallbackControlsBehavior;
@@ -28,4 +29,5 @@
 import org.apache.wicket.markup.html.GenericWebPage;
 import org.apache.wicket.markup.html.WebComponent;
+import org.apache.wicket.markup.html.WebMarkupContainer;
 import org.apache.wicket.markup.html.basic.Label;
 import org.apache.wicket.markup.html.link.ExternalLink;
@@ -177,7 +179,9 @@
         add(new ExternalLink("help", vloConfig.getHelpUrl()));
 
+        // add 'class' attribute to header indicating version qualifier (e.g. 'beta')
+        add(new WebMarkupContainer("header").add(new AttributeAppender("class", VloWicketApplication.get().getAppVersionQualifier())));
+
         add(new HideJavascriptFallbackControlsBehavior());
     }
 
-
 }
Index: /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/panels/record/HierarchyPanel.java
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/panels/record/HierarchyPanel.java	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/java/eu/clarin/cmdi/vlo/wicket/panels/record/HierarchyPanel.java	(revision 6412)
@@ -21,4 +21,5 @@
 import eu.clarin.cmdi.vlo.FacetConstants;
 import eu.clarin.cmdi.vlo.service.solr.SolrDocumentService;
+import eu.clarin.cmdi.vlo.wicket.components.IndicatingNestedTree;
 import eu.clarin.cmdi.vlo.wicket.components.NamedRecordPageLink;
 import eu.clarin.cmdi.vlo.wicket.model.SolrDocumentModel;
@@ -30,6 +31,7 @@
 import org.apache.wicket.ajax.AjaxRequestTarget;
 import org.apache.wicket.behavior.AttributeAppender;
+import org.apache.wicket.behavior.Behavior;
 import org.apache.wicket.extensions.ajax.markup.html.IndicatingAjaxFallbackLink;
-import org.apache.wicket.extensions.markup.html.repeater.tree.DefaultNestedTree;
+import org.apache.wicket.extensions.markup.html.repeater.tree.AbstractTree;
 import org.apache.wicket.extensions.markup.html.repeater.util.SortableTreeProvider;
 import org.apache.wicket.markup.html.WebMarkupContainer;
@@ -42,4 +44,5 @@
 import org.apache.wicket.model.AbstractReadOnlyModel;
 import org.apache.wicket.model.IModel;
+import org.apache.wicket.model.Model;
 import org.apache.wicket.model.PropertyModel;
 import org.apache.wicket.spring.injection.annot.SpringBean;
@@ -60,12 +63,19 @@
 
     private final IDataProvider<SolrDocument> parentsProvider;
+    private final AbstractTree<SolrDocument> tree;
+    private final IModel<SolrDocument> pageDocumentModel;
 
     public HierarchyPanel(String id, IModel<SolrDocument> documentModel) {
         super(id, documentModel);
+        pageDocumentModel = documentModel;
 
         parentsProvider = new ParentsDataProvider();
 
         add(createParentLinks("parents"));
-        add(createTree("tree"));
+
+        tree = createTree("tree");
+        add(tree);
+
+        setOutputMarkupId(true);
     }
 
@@ -79,6 +89,28 @@
 
             @Override
-            protected void populateItem(Item<SolrDocument> item) {
+            protected void populateItem(final Item<SolrDocument> item) {
                 item.add(new NamedRecordPageLink("link", item.getModel()));
+                item.add(new IndicatingAjaxFallbackLink("up") {
+
+                    @Override
+                    public void onClick(AjaxRequestTarget target) {
+                        // tree root up one level, expand root for traceability by user
+                        HierarchyPanel.this.setModel(item.getModel());
+                        tree.expand(item.getModelObject());
+                        if (target != null) {
+                            target.add(HierarchyPanel.this);
+                        }
+                    }
+                });
+                
+                item.add(new Behavior() {
+
+                    @Override
+                    public void onConfigure(Component component) {
+                        // null parent, hide
+                        component.setVisible(item.getModelObject() != null);
+                    }
+
+                });
             }
 
@@ -116,6 +148,6 @@
     }
 
-    private Component createTree(String id) {
-        final DefaultNestedTree<SolrDocument> tree = new DefaultNestedTree<SolrDocument>(id, new HierarchyTreeProvider()) {
+    private AbstractTree<SolrDocument> createTree(String id) {
+        final AbstractTree<SolrDocument> result = new IndicatingNestedTree<SolrDocument>(id, new HierarchyTreeProvider()) {
 
             @Override
@@ -125,5 +157,5 @@
                     @Override
                     protected void onConfigure() {
-                        setEnabled(!node.equals(HierarchyPanel.this.getModel()));
+                        setEnabled(!node.equals(pageDocumentModel));
                     }
                 };
@@ -132,5 +164,5 @@
         };
         // style of tree depends on presence of parent nodes
-        tree.add(new AttributeAppender("class", new AbstractReadOnlyModel<String>() {
+        result.add(new AttributeAppender("class", new AbstractReadOnlyModel<String>() {
 
             @Override
@@ -143,5 +175,5 @@
             }
         }, " "));
-        return tree;
+        return result;
     }
 
@@ -149,4 +181,5 @@
     public void detachModels() {
         super.detachModels();
+        pageDocumentModel.detach();
     }
 
@@ -170,7 +203,6 @@
 
                 @Override
-                public SolrDocument apply(Object input) {
-                    String childId = input.toString();
-                    return documentService.getDocument(childId);
+                public SolrDocument apply(Object childId) {
+                    return documentService.getDocument(childId.toString());
                 }
             });
@@ -223,5 +255,10 @@
         @Override
         public IModel<SolrDocument> model(SolrDocument object) {
-            return new SolrDocumentModel(object);
+            if (object == null) {
+                // dangling hasPart references can happen...
+                return new Model<>();
+            } else {
+                return new SolrDocumentModel(object);
+            }
         }
 
Index: /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/js/eu/clarin/cmdi/vlo/wicket/pages/searchhi.js
===================================================================
--- /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/js/eu/clarin/cmdi/vlo/wicket/pages/searchhi.js	(revision 6411)
+++ /vlo/branches/vlo-3.3-oeaw/vlo-web-app/src/main/js/eu/clarin/cmdi/vlo/wicket/pages/searchhi.js	(revision 6412)
@@ -13,5 +13,6 @@
     "and",
     "or",
-    "not"
+    "not",
+    "to"
 ];
 
